% author: Marcel Garling 2019
% COSY
function accuracy = testKnn2(mem, memY, rep, repY, memory_start_size, k, from)

% % accuracy after learning
% fill memory

if exist('from','var')
    p = from;
else
p = memory_start_size + 1;
end

total = 0;
correct = 0;

while p <= size(rep,1)
    % classify
    % get next drink
    x = rep(p,:);
    y = repY(p,:);

    % calculate euclidean distances
    euc = sqrt(sum((x - mem) .^2 , 2));

     % get classes of elements with smallest distances
    counter = zeros(3,1);
    for i=1:k
       [num, index] = min(euc);
        page = memY(index);
        counter(page) = counter(page) + 1;

        % identify
        ind = find(euc == num,1);
        euc(ind) = NaN;
    end
    [~,yi] = max(counter);
    
    
    if yi == y
        correct = correct + 1;
    end
    total = total + 1;
    
    p = p + 1;
end

accuracy = correct/total;


end

